SystemOrganization addCategory: #'MultiColumn Lists-Core'!

ScrollPane subclass: #MultiColumnListMorph
	instanceVariableNames: 'list selectedMorph selection getListSelector getIndexSelector setIndexSelector keystrokeActionSelector autoDeselect font lastKeystrokeTime lastKeystrokes lastClickTime doubleClickSelector potentialDropMorph header origObjects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumn Lists-Core'!

!MultiColumnListMorph methodsFor: 'selections' stamp: 'cbc 9/4/2003 13:28'!
informNewSelection: index

	(model isNil or: [setIndexSelector isNil]) ifTrue: [^self].
	model perform: setIndexSelector withEnoughArguments: { selection value }! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 4/30/2003 07:50'!
header: arrayOfStringsForHeader
	| f |

	arrayOfStringsForHeader ifNil: [
		header isNil ifTrue: [^nil].
		header scrolls ifFalse: [header delete].
		header _ nil.
			self resizeScroller.
		^self recalcSizes
	].
	(arrayOfStringsForHeader isKindOf: Array) ifTrue: [
		f _ MultiColumnListHeader on: arrayOfStringsForHeader.
		f keepHeaderAtTop.
	].
	f = header ifTrue: [^nil].
	(header notNil and: [header scrolls not]) ifTrue: [
		header delete.
		header _ nil.
		self resizeScroller.
	].
	header _ f.
	f _ TextStyle defaultFont emphasized: 1.
	header font: f; backgroundColor: Color gray.
	header scrolls ifFalse: [|bnd|
		bnd _ self rawInnerBounds.
		bnd _ bnd bottom: (bnd top + header neededHeight).
		bnd _ bnd left: (bnd left + 3).
		header bounds: bnd.
		self addMorph: header.
		header bounds: bnd.
		self resizeScroller.
		scroller changed.
	].
	self recalcSizes! !

!MultiColumnListMorph methodsFor: 'drawing' stamp: 'cbc 9/4/2003 10:42'!
drawOn: aCanvas
	"Draw the list on the canvas, and possibly also draw frame feedback"

	| colorToFillWith areaToFill next bnd |

	(header notNil and: [header scrolls not]) ifTrue: [
		bnd _ header bounds right: self rawInnerBounds right.
		header bounds: bnd.
	].
	super drawOn: aCanvas.
	
"	selectedMorph ifNotNil:
		[colorToFillWith _ color.
		next _ self.
		[colorToFillWith isTransparent and: [(next _ next owner) notNil]] whileTrue:
			[colorToFillWith _ next color].
		colorToFillWith _ colorToFillWith luminance < 0.5
			ifTrue:
				[colorToFillWith muchLighter]
			ifFalse:
				[colorToFillWith darker].

		areaToFill _ ((scroller transformFrom: self) localBoundsToGlobal: selectedMorph bounds)
						intersect: scroller bounds.
		aCanvas fillRectangle: areaToFill color: colorToFillWith]."

	self hasFocus ifTrue:
		[aCanvas frameRectangle: scroller bounds color: Preferences keyboardFocusColor]! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 5/5/2003 17:25'!
maximumSelection
	^list size! !

!MultiColumnListMorph class methodsFor: 'examples' stamp: 'cbc 6/20/2003 16:03'!
example2
	"Show a simple list box with a header, based on an array of Strings."
	"
		MultiColumnListMorph example2
	"
	|pmcolm theList|

	theList _ #( '1' '2' '3' '4' '5' '6' '7' '8' '9' '11' '12' '13' '14' '15' '16' '17' '18' '19' ).
	pmcolm _ MultiColumnListMorph 
		on: nil 
		list: theList 
		initialSelectedObject: nil 
		changeSelected: nil.
	pmcolm header: #( 'Numbers' ).
	pmcolm openInWorld! !

!MultiColumnListMorph methodsFor: 'initialization' stamp: 'cbc 9/4/2003 11:25'!
on: anObject list: theList initialSelectedObject: initialSelectedObject changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel 
	self model: anObject.
	self setSetIndexSelector: setSelectionSel.
	getMenuSelector _ getMenuSel.
	keystrokeActionSelector _ keyActionSel.
	autoDeselect _ true.
	self borderWidth: 1.
	self list: theList.
	self selection: initialSelectedObject.
	self initForKeystrokes

! !

!MultiColumnListMorph class methodsFor: 'examples' stamp: 'cbc 6/20/2003 16:06'!
example3
	"Show a list box with multiple columns, based on an array of arrays of Strings."
	"
		MultiColumnListMorph example3
	"
	|pmcolm theList|

	theList _ (OrderedCollection new: 7)
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'x' '29/4%' 'YAHOO' );
	yourself.
	pmcolm _ MultiColumnListMorph 
		on: nil 
		list: theList 
		initialSelectedObject: nil 
		changeSelected: nil.
	pmcolm openInWorld! !

!MultiColumnListMorph methodsFor: 'selections' stamp: 'cbc 9/4/2003 16:23'!
getCurrentSelectionIndex
	^selection value! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 4/29/2003 23:09'!
leftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	scroller localSubmorphBounds ifNil: [^ 0].
	^ (self totalScrollRange - bounds height + (self headerAdjustment) roundTo: self scrollDeltaHeight) max: 0
! !

!MultiColumnListMorph methodsFor: 'events' stamp: 'cbc 9/17/2003 15:16'!
mouseDown: evt
	|pos newBounds item|

	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	pos _ (evt transformedBy: (scroller transformFrom: self)) position.
	newBounds _ (0@0 corner: bounds extent) translateBy: (0 @ (scroller offset y)).
	pos y < newBounds top ifTrue: [^super mouseDown: evt].
	item _ (list detect: [:l| l includesPoint: pos] ifNone: [^self]).
^self selectionIndex: (list indexOf: item)
! !

!MultiColumnListMorph methodsFor: 'events' stamp: 'cbc 9/8/2003 13:54'!
specialKeyPressed: asciiValue
	"A special key with the given ascii-value was pressed; dispatch it"

	| oldSelection nextSelection max howManyItemsShowing |
	asciiValue = 27 ifTrue: 
		[" escape key"
		^ ActiveEvent shiftPressed
			ifTrue:
				[ActiveWorld putUpWorldMenuFromEscapeKey]
			ifFalse:
				[self yellowButtonActivity: false]].

	max _ self maximumSelection.
	max > 0 ifFalse: [^ self].
	nextSelection _ oldSelection _ self getCurrentSelectionIndex.
	asciiValue = 31 ifTrue: 
		[" down arrow"
		oldSelection isNil
			ifTrue: [scrollBar scrollDown: 1]
			ifFalse: [
				nextSelection _ oldSelection + 1.
				nextSelection > max ifTrue: [nextSelection _ 1].
			]
		].
	asciiValue = 30 ifTrue: 
		[" up arrow"
		oldSelection isNil
			ifTrue: [scrollBar scrollUp: 1]
			ifFalse: [
				nextSelection _ oldSelection - 1.
				nextSelection < 1 ifTrue: [nextSelection _ max].
			]
		].
	asciiValue = 1 ifTrue:
		[" home"
		oldSelection isNil
			ifTrue: [scrollBar scrollUp: max]
			ifFalse: [nextSelection _ 1]].
	asciiValue = 4 ifTrue:
		[" end"
		oldSelection isNil
			ifTrue: [scrollBar scrollDown: max]
			ifFalse: [nextSelection _ max]].
	howManyItemsShowing _ self numSelectionsInView.
	asciiValue = 11 ifTrue:
		[" page up"
		oldSelection ifNotNil: [nextSelection _ 1 max: oldSelection - howManyItemsShowing]].
	asciiValue = 12 ifTrue:
		[" page down"
		oldSelection ifNotNil: [	nextSelection _ oldSelection + howManyItemsShowing min: max]].
"	model okToChange ifFalse: [^ self]."
	"No change if model is locked"
"	oldSelection = nextSelection ifTrue: [^ self flash]."
"	^ self changeModelSelection: nextSelection"
	oldSelection = nextSelection ifFalse: [self selectionIndex: nextSelection].! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 4/29/2003 22:21'!
rawInnerBounds
	^super innerBounds.
! !

!MultiColumnListMorph methodsFor: 'events' stamp: 'cbc 9/19/2003 10:49'!
modifierKeyPressed: aChar 
	| args |
	keystrokeActionSelector ifNil: [^nil].
	model ifNil: [^nil].
	args := keystrokeActionSelector numArgs.
	args = 1 ifTrue: [^model perform: keystrokeActionSelector with: aChar].
	args = 2 
		ifTrue: 
			[^model 
				perform: keystrokeActionSelector
				with: aChar
				with: self].
	^self error: 'keystrokeActionSelector must be a 1- or 2-keyword symbol'! !

!MultiColumnListMorph class methodsFor: 'examples' stamp: 'cbc 6/20/2003 16:03'!
example1
	"Show a simple list box, based on an array of Strings."
	"
		MultiColumnListMorph example1
	"
	|pmcolm theList|

	theList _ #( '1' '2' '3' '4' '5' '6' '7' '8' '9' '11' '12' '13' '14' '15' '16' '17' '18' '19' ).
	pmcolm _ MultiColumnListMorph 
		on: nil 
		list: theList 
		initialSelectedObject: nil 
		changeSelected: nil.
	pmcolm openInWorld! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 5/16/2003 13:52'!
wantsKeyboardFocusFor: aMorph
	^ true! !

!MultiColumnListMorph methodsFor: 'initialization' stamp: 'cbc 4/23/2003 14:37'!
initForKeystrokes! !

!MultiColumnListMorph methodsFor: 'events' stamp: 'cbc 5/5/2003 17:15'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining (versus losing) the keyboard focus"

	self changed "to redraw border feedback"! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 5/16/2003 13:55'!
numSelectionsInView

	^(self innerBounds height / list first bounds height) asInteger! !

!MultiColumnListMorph methodsFor: 'drawing' stamp: 'cbc 9/19/2003 10:49'!
recalcSizes
	| maxSizes h loc |
	(header isNil and: [list isEmpty]) 
		ifTrue: 
			[scroller removeAllMorphs.
			self setScrollDeltas.
			"		self selectedMorph: nil."
			^self changed].
	header isNil 
		ifTrue: 
			[list isEmpty ifTrue: [^nil].
			maxSizes := Array new: list first size.
			maxSizes atAllPut: 0]
		ifFalse: [maxSizes := header sizes].
	list do: 
			[:ssm | 
			ssm sizes 
				withIndexDo: [:sz :idx | maxSizes at: idx put: (sz max: (maxSizes at: idx))]].
	list do: [:ssm | ssm sizes: maxSizes].
	header ifNotNil: [header sizes: maxSizes].
	"	self highlightSelector ifNotNil:
		[model perform: self highlightSelector with: list with: morphList].
"
	"Lay items out vertically and install them in the scroller"
	h := list isEmpty 
		ifTrue: [header neededHeight]
		ifFalse: [list first neededHeight].
	loc := 0 @ 0.
	(header notNil and: [header scrolls]) 
		ifTrue: 
			[header bounds: (loc extent: 9999 @ header neededHeight).
			loc := loc + (0 @ header neededHeight)].
	list do: 
			[:m | 
			m
				bounds: (loc extent: 9999 @ h);
				displayBounds: (0 @ 0 corner: bounds extent).
			loc := loc + (0 @ h)].
	scroller removeAllMorphs.
	scroller layoutPolicy: SimpleListLayout new.
	(header isNil or: [header scrolls not]) 
		ifTrue: [scroller addAllMorphs: list]
		ifFalse: [scroller addAllMorphs: (list copyWithFirst: header)].

	"	index _ self getCurrentSelectionIndex."
	"	self selectedMorph: ((index isNil or: [index = 0 or: [index > morphList size]]) ifTrue: [nil] ifFalse: [morphList at: index])."
	self setScrollDeltas.
	scrollBar setValue: 0.0! !

!MultiColumnListMorph class methodsFor: 'instance creation' stamp: 'cbc 4/23/2003 12:59'!
on: anObject list: theList initialSelectedObject: initialSelectedObject changeSelected: setSelectionSel
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		on: anObject
		list: theList
		initialSelectedObject: initialSelectedObject
		changeSelected: setSelectionSel
		menu: nil
		keystroke: #arrowKey:from:		"default"

! !

!MultiColumnListMorph methodsFor: 'scrolling' stamp: 'cbc 4/29/2003 21:54'!
scrollBarValue: scrollValue
	|newBounds|

	super scrollBarValue: scrollValue.
	newBounds _ (0@0 corner: bounds extent) translateBy: (0 @ (scroller offset y)).
	list do: [:m | m displayBounds: newBounds].
! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 5/5/2003 17:15'!
handlesBasicKeys
	^false! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 11:26'!
setSetIndexSelector: setSelectionSel
	setIndexSelector _ setSelectionSel! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 4/29/2003 23:08'!
headerAdjustment
	header ifNotNil: [header scrolls ifFalse: [^header neededHeight]].
	^0! !

!MultiColumnListMorph methodsFor: 'selections' stamp: 'cbc 9/9/2003 09:55'!
selectionIndex: index
	(index isNil or: [index = 0]) ifTrue: [
		selectedMorph ifNil: [^self].
		selectedMorph isSelected: false.
		selectedMorph _ nil.
		selection _ nil.
		^self changed.
	].
	selectedMorph ifNotNil: [selectedMorph isSelected: false].
	selection _ (Association key: (origObjects at: index) value: index).
	selectedMorph _ list at: index.
	selectedMorph isSelected: true.
	self changed.
	self informNewSelection: index.! !

!MultiColumnListMorph methodsFor: 'selections' stamp: 'cbc 11/19/2003 15:14'!
selection: object
	object ifNil: [
		selectedMorph ifNil: [^self].
		selectedMorph isSelected: false.
		selectedMorph _ nil.
		selection _ nil.
		self changed.
	].
	selectedMorph ifNotNil: [selectedMorph isSelected: false].
	selection _ (object -> (origObjects indexOf: object)).
	selection value = 0 ifTrue: [^self selection: nil].
	selectedMorph _ list at: selection value.
	selectedMorph isSelected: true.
	self changed.
	self informNewSelection: selection value! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 5/5/2003 17:13'!
handlesKeyboard: evt
	^true! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 9/10/2003 11:08'!
list: listArrays
	"For now, we are just using arrays of strings instead of objects.  Full usefullness to follow"
	"Set the receiver's list as specified"
	"cbc 4/29/2003 17:11 - Allow a simple array of strings to be passed in, and transform them
		an array of arrays containing each string."

	list _ listArrays ifNil: [Array new].
	origObjects _ list.

	"Convert the list to a list of StackedStringMorphs"
	font _ TextStyle defaultFont.
	list _ list asArray collect: [:array| (StackedStringMorph on: (array isString ifTrue: [Array with: array] ifFalse: [array])) font: font; backgroundColor: self color; yourself ].

	self recalcSizes.! !

!MultiColumnListMorph class methodsFor: 'examples' stamp: 'cbc 6/20/2003 16:05'!
example4
	"Show a list box with multiple columns with headers, based on an array of arrays of Strings."
	"
		MultiColumnListMorph example4
	"
	|pmcolm theList|

	theList _ (OrderedCollection new: 7)
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'me' 'you' 'him' );
	add: #( 'mih' 'uoy' 'em' );
	add: #( 'x' '29/4%' 'YAHOO' );
	yourself.
	pmcolm _ MultiColumnListMorph 
		on: nil 
		list: theList 
		initialSelectedObject: nil 
		changeSelected: nil.
	pmcolm header: #( 'Column 1' 'Column 2' 'Column 3').
	pmcolm openInWorld! !

!MultiColumnListMorph methodsFor: 'accessing' stamp: 'cbc 4/29/2003 22:54'!
innerBounds
	| inner |
	inner _ super innerBounds.
	header ifNotNil: [header scrolls ifFalse: [inner _ inner top: (inner top + header neededHeight)]].
	retractableScrollBar | (submorphs includes: scrollBar) not
		ifTrue: [^ inner]
		ifFalse: [^ (scrollBarOnLeft
					ifTrue: [scrollBar right @ inner top corner: inner bottomRight]
					ifFalse: [inner topLeft corner: scrollBar left @ inner bottom])]! !

!MultiColumnListMorph methodsFor: 'events' stamp: 'cbc 9/19/2003 10:51'!
keyStroke: event 
	"Process keys 
	specialKeys are things like up, down, etc. ALWAYS HANDLED 
	modifierKeys are regular characters either 1) accompanied with ctrl, 
	cmd or 2) any character if the list doesn't want to handle basic 
	keys (handlesBasicKeys returns false) 
	basicKeys are any characters"

	| aChar aSpecialKey |
	(self scrollByKeyboard: event) ifTrue: [^self].
	aChar := event keyCharacter.
	aSpecialKey := aChar asciiValue.
	aSpecialKey < 32 ifTrue: [^self specialKeyPressed: aSpecialKey].
	(event anyModifierKeyPressed or: [self handlesBasicKeys not]) 
		ifTrue: [^self modifierKeyPressed: aChar].
"	^self basicKeyPressed: aChar"! !

!SequenceableCollection methodsFor: '*multiColumn Lists' stamp: 'cbc 4/25/2003 09:42'!
copyWithFirst: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver and has 
	newElement at the FIRST element."

	| newIC |
	newIC _ self similarSpeciesInstance: self size + 1.
	newIC at: 1 put: newElement.
	newIC 
		replaceFrom: 2
		to: self size + 1
		with: self
		startingAt: 1.
	^newIC! !

LayoutPolicy subclass: #SimpleListLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumn Lists-Core'!

!SimpleListLayout commentStamp: 'cbc 9/8/2003 13:33' prior: 0!
I lay out items of a list top to bottom, left justified. Each item's height is equal, making many calculations fast. I am only suitable for Lists that scroll vertically only - I return a valid height but bogus width for my submorphs for speed.

Because items are equal heights, we can quickly decide which ones must be drawn in a given viewport. Very helpful for PluggableLists.!

!SimpleListLayout methodsFor: 'layout' stamp: ''!
submorphHeightOf: aMorph
" I can quickly determine the submorph height for a simple list."
| submorphs |
submorphs _ aMorph submorphs.
^(submorphs size)*((submorphs at: 1) height)! !

!SimpleListLayout methodsFor: 'layout' stamp: ''!
submorphsOf: aMorph touching: aBox
	| firstItem submorphs firstTop transform firstVisibleIndex lastVisibleIndex |
	"Return submorphs of aMorph that may be visible through aBox"
	submorphs _ aMorph submorphs.
	(submorphs size = 0) ifTrue:[^submorphs].
	transform _ aMorph transformFromWorld.
	firstItem _ submorphs at: 1.
	firstTop _ transform localPointToGlobal: firstItem top.
	firstVisibleIndex _ (((aMorph top - firstTop ) // (firstItem height)) y ) + 1
		max: 1.
	lastVisibleIndex _ (firstVisibleIndex + (aMorph height // firstItem height) roundUpTo:1) 
		min: submorphs size.

"^submorphs"
"Transcript show: 'visible:', firstVisibleIndex printString, ':', lastVisibleIndex printString; cr."
^submorphs copyFrom: firstVisibleIndex to: lastVisibleIndex! !

!SimpleListLayout methodsFor: 'layout' stamp: ''!
layout: aMorph in: box

	| submorphs h loc |
	submorphs _ aMorph submorphs.

	"Lay items out vertically and install them in the scroller"
	h _ submorphs first height "self listItemHeight".
	loc _ 0@0.
	submorphs do: [:m | m bounds: (loc extent: 9999@h).  loc _ loc + (0@h)].

	"Transcript show: submorphs size printString;cr."! !

Morph subclass: #StackedStringMorph
	instanceVariableNames: 'strings sizes alignments fitMethod locations font backgroundColor displayBounds selected '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumn Lists-Core'!

!StackedStringMorph commentStamp: 'cbc 4/22/2003 17:10' prior: 0!
This morph takes an array of strings, and stacks them one after the other on a single line.!

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 15:11'!
neededHeight
	"Return the height that we thing we need."
	^self font height + 4! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 13:59'!
sizes: arrayOfStringSizes
	arrayOfStringSizes size = strings size ifFalse: [self error: 'Setting the wrong number of sizes!!'].
	sizes _arrayOfStringSizes.
	locations _ Array new: strings size.! !

!StackedStringMorph class methodsFor: 'instance creation' stamp: 'cbc 9/4/2003 13:52'!
on: arrayOfStrings
	"Create a default representation."
	|inst|

	arrayOfStrings class = self ifTrue: [^arrayOfStrings]. "Well, if we are passed an instance of ourselves, just return it."
	inst _ self new.
	inst
		setStrings: arrayOfStrings;
		defaultAlignments;
		setSquishLeft;
		color: Color black.
^inst! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 10:10'!
isSelected: boolean
	"If we are selected, we need to be highlighted."

	selected _ boolean! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 10:17'!
color
	color ifNil: [color _ Color black].
	^color orColorUnlike: self backgroundColor! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 10:19'!
isSelected
	^selected ifNil: [selected _ false]! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 16:00'!
font: aStrikeFont
	font _ aStrikeFont.
	locations _ Array new: strings size.
	self calculateSizes.! !

StackedStringMorph subclass: #MultiColumnListHeader
	instanceVariableNames: 'scroll '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiColumn Lists-Core'!

!MultiColumnListHeader methodsFor: 'accessing' stamp: 'cbc 4/29/2003 21:59'!
scrolls

	^scroll ifNil: [scroll _ false].! !

!MultiColumnListHeader methodsFor: 'accessing' stamp: 'cbc 4/29/2003 21:59'!
scrollHeaderWithValues
	scroll _ true! !

!MultiColumnListHeader methodsFor: 'accessing' stamp: 'cbc 4/29/2003 22:00'!
keepHeaderAtTop
	"i.e., don't scroll it off the top of the list"
	scroll _ false! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/22/2003 17:24'!
setSquishLeft
	self fitMethod: #squishLeft	! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 13:58'!
sizes
	^sizes! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/22/2003 17:14'!
defaultAlignments
	alignments _ Array new: strings size.
	alignments atAllPut: #left! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 16:03'!
backgroundColor: aColor
	backgroundColor _ aColor! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 10:57'!
includesPoint: aPoint
	bounds top > aPoint y ifTrue: [^false].
^bounds bottom >= aPoint y! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/25/2003 17:15'!
displayBounds
	^displayBounds ifNil: [displayBounds _ Display boundingBox]! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 15:21'!
size
	^strings size! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 16:00'!
calculateSizes
	"Figure out how big the strings are going to be"
	|fontSizer|

	fontSizer _ CharacterScanner new initializeStringMeasurer.
	strings withIndexDo: [:str :idx|
		sizes at: idx put: (fontSizer measureString: str inFont: self font from: 1 to: str size).
	].! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 15:59'!
setStrings: arrayOfStrings

	strings _ arrayOfStrings.
	sizes _ Array new: strings size.
	locations _ Array new: strings size.
	self calculateSizes.
! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/23/2003 15:11'!
font
	^font ifNil: [font _ TextStyle defaultFont]! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/22/2003 17:16'!
fitMethod: symbol
	"This is how the strings will be stacked within the space given.  The options are:
		#squishLeft - stack everything as close to the left size of the space as possible.
		#spread - (Not Implement) Take up the whole space, spreading out as much as possible
	"

	fitMethod _ symbol.
! !

!StackedStringMorph methodsFor: 'drawing' stamp: 'cbc 4/25/2003 17:15'!
drawOn: aCanvas
	"Draw it out"

	(bounds top > self displayBounds bottom or: [bounds bottom < self displayBounds top]) ifTrue: [^self].
	self perform: fitMethod.
	aCanvas fillRectangle: bounds color: self backgroundColor.
	strings withIndexDo: [:str :idx|| x y bnd |
		x _ locations at: idx.
		x < bounds right ifTrue: [
			y _ (x + (sizes at: idx)) min: (bounds right - 2).
			bnd _ (x @ (bounds top + 2)) corner: (y @ (bounds bottom - 2)).
			aCanvas drawString: str in: bnd font: self font color: self color.
			idx < strings size ifTrue: [
				x _ (locations at: (idx + 1)) - 3.
				x < bounds right ifTrue: [
					aCanvas line: (x @ (bounds top)) to: (x @ (bounds top + 4 + self font height)) color: Color black
				].
			].
		].
	].
! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 4/25/2003 17:11'!
displayBounds: rectangle
	displayBounds _ rectangle! !

!StackedStringMorph methodsFor: 'accessing' stamp: 'cbc 9/4/2003 11:00'!
backgroundColor
	self isSelected
		ifFalse: [^backgroundColor ifNil: [backgroundColor _ Color white]]
		ifTrue: [^Color blue muchLighter]! !

!StackedStringMorph methodsFor: 'drawing' stamp: 'cbc 4/23/2003 09:35'!
squishLeft
	"Squish everything as far left as we can"
	| space x |

	space _ 5.		"2 pixels space, 1 pixel bar, 2 pixels space"
	x _ bounds left + 2.
	sizes withIndexDo: [:size :idx|
		locations at: idx put: x.
		x _ x + (sizes at: idx) + space.
	].! !
